/*
 * Oleg Moskalenko, 2013
 */

#include "udpbug.h"

int main()
{
	ioa_addr server_addr, client_addr, remote_addr;

	init_addrs(&server_addr,&client_addr);

	/* Step 4: */
	int client_fd = open_socket(); /* SOCKET C */

	/* Step 5: */
	addr_bind(client_fd, &client_addr);

	/* Step 6: */
	printf("Step 6 start\n");
	addr_connect(client_fd, &server_addr);
	udp_send(client_fd, NULL, PACKET1, (int)strlen(PACKET1));
	printf("Step 6 end\n");
	sleep(1);


	/* Step 12: */
	printf("Step 12 start\n");
	char s[2048];
	int plen = udp_recvfrom(client_fd, &remote_addr, s, (int)sizeof(s));

	if(plen<0) {
		fprintf(stderr,"Fatal error: cannot receive packet 2.\n");
		exit(-1);
	}
	if(!addr_eq(&server_addr,&remote_addr)) {
		fprintf(stderr,"Fatal error: Packet 2 received from unknown source.\n");
		exit(-1);
	}
	s[plen]=0;
	if(strcmp(s,PACKET2)) {
		fprintf(stderr,"Fatal error: Wrong packet 2 received.\n");
		exit(-1);
	}
	printf("Step 12 end\n");

	/* Step 13: */
	udp_send(client_fd, NULL, PACKET3, (int)strlen(PACKET3));

	/* Done, see what server does. */

	return 0;
}

